\documentclass{standalone}

\input{../../macros/macros}

\usepackage{../../../msc}

\begin{document}
\setlength{\firstlevelheight}{0.4cm}
\begin{msc}[msc keyword=, draw frame = none, instance distance=4cm,%
        head top distance=0cm, foot distance=0cm]{}
\declinst{p}{}{P (IoT)}
\declinst{v}{}{V (Smartphone)}
\action*{nonce $k$}{p}
\action*{nonce $n_v, k_{vp}$}{v}
\nextlevel[2]
\mess{$\pair{P}{\pubkey{k}}$}{p}{v}
\nextlevel[1.5]
\mess*{$n_v$}{v}{p}
\measure[r]{max $\Delta$}{v}{v}[2]
\nextlevel[1.5]
\mess*{$\signFunc(n_v, k)$}{p}{v}
\nextlevel[1.5]
\mess{$\enc{k_{vp}}{\pubkey{k}}$}{v}{p}
\nextlevel[1.5]
\mess{$\enc{n_v}{k_{vp}}$}{p}{v}
\nextlevel[1]
\condition*{$k_{vp}$ is secret}{v}
\condition*{$k_{vp}$ is secret}{p}
\nextlevel[2]
\condition*{$V$ is communicating with $P$}{v}
\nextlevel[1]
\end{msc}

\end{document}
